///home/berryj/link/bin/genMethods "-g" "-t" "Graph*" "-h" "Collection" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Collection.h" "-I" "LINK/graph/Graph.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Collection.h>

#include <LINK/graph/Graph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Graph* _Graph_;
typedef Collection<Graph* > _Collection_Graph__;

#define _Collection_Graph__DATA(x) ((Collection<Graph* >*) (EXTDATA(x)))
#define _Collection_Graph__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Graph* > >::type))
#define _Collection_Graph__ISNT_DATA(x) (!_Collection_Graph__IS_DATA(x))

#define _Collection_Graph__CXX_DATA(x) (*(Collection<Graph* >*) (EXTDATA(VAL(x))))
#define _Collection_Graph__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Graph* > >::type))
#define _Collection_Graph__CXX_ISNT_DATA(x) (!_Collection_Graph__CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_Graph__()
{
	Wrapper<_Collection_Graph__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_Graph__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Graph_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Graph_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Graph_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_Graph__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_Graph__Methods(void);

PRIMITIVE STk_init_methods__Collection_Graph__()
{
	STk_add_new_cpp_primitive("collection-Graph?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::collectionP);
	STk_add_new_cpp_primitive("mset-Graph1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::buildMSet);
	STk_add_new_cpp_primitive("set-Graph1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::buildSet);
	STk_add_new_cpp_primitive("sequence-Graph1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::buildSequence);
	STk_add_new_cpp_primitive("Collection-Graph-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-Graph-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-Graph", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-Graph", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-Graph", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-Graph->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::collection2STkList);
	STk_add_new_cpp_primitive("set-Graph->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-Graph->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::collection2STkList);
	STk_add_new_cpp_primitive("mset-Graph->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::collection2STkString);
	STk_add_new_cpp_primitive("set-Graph->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-Graph->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Graph_>::collection2STkString);

	addListMethod("mset-Graph",
		"mset-Graph1", LINK_NEW);
	addListMethod("set-Graph",
		"set-Graph1", LINK_NEW);
	addListMethod("sequence-Graph",
		"sequence-Graph1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_Graph__ >::name, 
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_Graph_ >::name, 
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_Graph__ >::name, 
		"<integer>",
		"Collection-Graph-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_Graph_ >::name, 
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_Graph_ >::name, 
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_Graph_ >::name, 
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_Graph__ >::name, 
		"Collection-Graph--", LINK_OVL);
	genExtra_Collection_Graph__Methods();
	return UNDEFINED;
}
